﻿// Demo.BatchApi
//
// Copyright © 2018 Eurostep
//
// All rights reserved.
//
// MIT License
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
// the Software, and to permit persons to whom the Software is furnished to do so,
// subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
// IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using Newtonsoft.Json.Linq;
using System;

namespace Demo.BatchApi
{
    public static partial class Program
    {
        public static JArray BatchCreate(string accessToken, string baseAddress, string spaceId)
        {
            JArray operations = new JArray();
            operations.Add(new JObject
            {
                ["method"] = "POST",
                ["href"] = $"{baseAddress}/api/space/{spaceId}/softtype/DesignPart/defaultIn",
                ["body"] = new JObject
                {
                    ["id"] = $"{Guid.NewGuid()}",
                    ["name"] = "Test DesignPart",
                    ["versionId"] = "A",
                    ["typeClass"] = new JObject
                    {
                        ["class"] = "TODO"
                    },
                    ["designDate"] = new JObject
                    {
                        ["date"] = "2018-06-01T00:00:00Z"
                    },
                    ["targetWeight"] = new JObject
                    {
                        ["value"] = 1234,
                        ["unit"] = "gram"
                    }
                }
            });
            operations.Add(new JObject
            {
                ["method"] = "POST",
                ["href"] = $"{baseAddress}/api/space/{spaceId}/softtype/DesignPart/defaultIn",
                ["body"] = new JObject
                {
                    ["id"] = $"{Guid.NewGuid()}",
                    ["name"] = "Test DesignPart",
                    ["versionId"] = "A",
                    ["typeClass"] = new JObject
                    {
                        ["class"] = "TODO"
                    },
                    ["designDate"] = new JObject
                    {
                        ["date"] = "2018-06-01T00:00:00Z"
                    },
                    ["targetWeight"] = new JObject
                    {
                        ["value"] = 1.2,
                        ["unit"] = "kilogram"
                    }
                }
            });

            return BatchCommit(accessToken, baseAddress, spaceId, operations);
        }
    }
}