﻿// Demo.BatchApi
//
// Copyright © 2018 Eurostep
//
// All rights reserved.
//
// MIT License
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
// the Software, and to permit persons to whom the Software is furnished to do so,
// subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
// IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using Newtonsoft.Json.Linq;
using System.Linq;

namespace Demo.BatchApi
{
    public static partial class Program
    {
        public static JArray BatchPromote(string accessToken, string baseAddress, string spaceId, JArray json)
        {
            JObject uoi1 = (JObject)json.First;
            JObject uoi2 = (JObject)json.Last;
            string oid1 = ((string)uoi1["body"]["href"]).Split('/').Last();
            string oid2 = ((string)uoi2["body"]["href"]).Split('/').Last();
            int uoiVersion1 = (int)uoi1["body"]["version"];
            int uoiVersion2 = (int)uoi2["body"]["version"];

            JArray operations = new JArray();
            operations.Add(new JObject
            {
                ["method"] = "PUT",
                ["href"] = $"{baseAddress}/api/space/{spaceId}/maturityAction/promote/{oid1}/commonReleaseProcessOEM/Review",
                ["headers"] = new JObject
                {
                    ["SAs-UOIVersion"] = uoiVersion1
                }
            });
            operations.Add(new JObject
            {
                ["method"] = "PUT",
                ["href"] = $"{baseAddress}/api/space/{spaceId}/maturityAction/promote/{oid2}/commonReleaseProcessOEM/Review",
                ["headers"] = new JObject
                {
                    ["SAs-UOIVersion"] = uoiVersion2
                }
            });

            return BatchCommit(accessToken, baseAddress, spaceId, operations);
        }
    }
}