﻿// Demo.BatchApi
//
// Copyright © 2018 Eurostep
//
// All rights reserved.
//
// MIT License
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
// the Software, and to permit persons to whom the Software is furnished to do so,
// subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
// IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using Newtonsoft.Json.Linq;
using System;

namespace Demo.BatchApi
{
    public static partial class Program
    {
        public static void Main(string[] args)
        {
            string baseAddress = @"https://my.machine1.net";
            string userName = "MyEmail";
            string password = "MyPassword";
            string clientName = "ResourceOwnerClientId";
            string clientSecret = "CLIENTSECRET";
            string spaceId = "mytestspace";

            try
            {
                JObject token = Authenticate(baseAddress, userName, password, clientName, clientSecret);
                string accessToken = (string)token["access_token"];

                Console.WriteLine("Batch Create");
                JArray createResult = BatchCreate(accessToken, baseAddress, spaceId);
                Console.WriteLine(createResult);

                Console.WriteLine("Batch Promote");
                JArray promoteResult = BatchPromote(accessToken, baseAddress, spaceId, createResult);
                Console.WriteLine(promoteResult);

                Console.WriteLine("Batch Get");
                JArray getResult = BatchGet(accessToken, baseAddress, spaceId, createResult);
                Console.WriteLine(getResult);

                Console.WriteLine("Batch Edit");
                JArray editResult = BatchEdit(accessToken, baseAddress, spaceId, getResult);
                Console.WriteLine(editResult);
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }
            Console.WriteLine("Press any key...");
            Console.ReadLine();
        }
    }
}